#include <qdp-config.h>

static QDP_Subset *timeslices = NULL;

static int
timeslice_func(int *coord, void *dum)
{
  return coord[NDIM-1];
}

void
print_pion(QDP_DiracPropagator *prop, int t0)
{
  int i, nt;
  QLA_Real *corr;

  /* get number of timeslices */
  nt = QDP_coord_size(NDIM-1);

  /* create subset for each timeslice */
  if(!timeslices) {
    timeslices = QDP_create_subset(timeslice_func, NULL, 0, nt);
  }

  /* allocate space for correlator on each timeslice */
  corr = (QLA_Real *) malloc(nt*sizeof(QLA_Real));

  /* do sum[trace(prop^+ prop)] over each timeslice */
  QDP_r_eq_norm2_P_multi(corr, prop, timeslices, nt);

  /* print result */
  printf0("BEGIN PION\n");
  for(i=0; i<nt; i++) {
    int t = (t0+i)%nt;
    printf0("%i\t%g\n", i, corr[t] );
  }
  printf0("END PION\n");

  free(corr);
}
