#include <qdp-config.h>

/* make a point source at point[] with color ic and spin is */
void
point_source(QDP_DiracFermion *src, int point[], int ic, int is)
{
  int n, i;
  QLA_DiracFermion *qladf;

  /* zero source field */
  QDP_D_eq_zero(src, QDP_all);

  /* expose the internal array of QLA objects */
  qladf = QDP_expose_D(src);

  /* find the node number and site index of point */
  n = QDP_node_number(point);
  i = QDP_index(point);

  /* if the point is on this node set it */
  if(n==QDP_this_node) {
    QLA_Complex z;
    QLA_c_eq_r(z, 1.0);
    QLA_c_eq_c(QLA_elem_D(qladf[i], ic, is), z);
  }

  /* "un-expose" the field */
  QDP_reset_D(src);
}
